MainWindow = class(Turbine.UI.Lotro.Window);

function MainWindow:Constructor()
	Turbine.UI.Lotro.Window.Constructor(self);

    self.Update = function()
        Plugins["Chatterbug"].Unload = saveSettings;
        self:SetWantsUpdates(false);
    end
    self:SetWantsUpdates(true);

	self:SetPosition(settings.mainwindow.position.left, settings.mainwindow.position.top);
	self:SetSize(settings.mainwindow.size.width, settings.mainwindow.size.height);
	self:SetText("Chatterbug");

    -- search label
    self.searchlabel = Turbine.UI.Label();
    self.searchlabel:SetParent(self);
    self.searchlabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
    self.searchlabel:SetForeColor(Turbine.UI.Color(0.8, 0.75, 0.5));
    self.searchlabel:SetPosition(30, 45);
    self.searchlabel:SetSize(60, 20);
    self.searchlabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
    self.searchlabel:SetText("Search:");

    -- search box
    self.searchbox = Turbine.UI.Lotro.TextBox();
    self.searchbox:SetParent(self);
    self.searchbox:SetFont(Turbine.UI.Lotro.Font.Verdana14);
    self.searchbox:SetPosition(80, 45);
    self.searchbox:SetSize(140, 20);
    self.searchbox:SetMultiline(false);
    -- workarounds for lack of TextBox.TextChanged event
    self.searchbox.Text = "";
    self.searchbox:SetWantsUpdates(false);
    self.searchbox.FocusGained = function()
        self.searchbox:SetWantsUpdates(true);
        self:SetWantsKeyEvents(true);
    end
    self.searchbox.FocusLost = function()
        self.searchbox:SetWantsUpdates(false);
    end
    self.searchbox.Update = function()
        if self.searchbox.Text ~= self.searchbox:GetText() then
            self.searchbox.Text = self.searchbox:GetText();
            filter = string.lower(self.searchbox.Text);
            self:ReloadHistory();
        end
    end

    -- unfocus searchbox if esc or enter key is hit
    self.KeyDown = function(sender, args)
        if args.Action == Turbine.UI.Lotro.Action.Escape or
            args.Action == 162 then
            self.text:Focus();
            self:SetWantsKeyEvents(false);
        end
    end

    -- settings button
    self.settingsbutton = Turbine.UI.Lotro.Button();
    self.settingsbutton:SetParent(self);
    self.settingsbutton:SetPosition(230, 45);
    self.settingsbutton:SetSize(80, 20);
    self.settingsbutton:SetText("Settings");
    self.settingsbutton.Click = function(sender, args)
        settingsWindow:Toggle();
    end
    
    -- scrollbar
    self.scrollbar = Turbine.UI.Lotro.ScrollBar();
    self.scrollbar:SetParent(self);
    self.scrollbar:SetOrientation(Turbine.UI.Orientation.Vertical);

    -- text display
    self.text = Turbine.UI.Label();
    self.text:SetParent(self);
    self.text:SetSelectable(true);
    self.text:SetFont(Turbine.UI.Lotro.Font.Verdana14);
    self.text:SetForeColor(Turbine.UI.Color(0.8, 0.8, 0.8));
    self.text:SetPosition(30, 80);
    self.text:SetVerticalScrollBar(self.scrollbar);

	-- resize control
	self.resizeCtrl = Turbine.UI.Control();
	self.resizeCtrl:SetParent(self);
	self.resizeCtrl:SetSize(20, 20);
	self.resizeCtrl:SetPosition(self:GetWidth() - 20, self:GetHeight() - 20);
	self.resizeCtrl.MouseDown = function(sender, args)
		sender.dragStartX = args.X;
		sender.dragStartY = args.Y;
		sender.dragging = true;
	end
	self.resizeCtrl.MouseUp = function(sender, args)
		sender.dragging = false;
	end;
	self.resizeCtrl.MouseMove = function(sender, args)
		local width, height = self:GetSize();
		if (sender.dragging) then
			self:SetSize(width + (args.X - sender.dragStartX),
				height + (args.Y - sender.dragStartY));
			if (self:GetWidth() < 350) then
				self:SetWidth(350);
			end
			if (self:GetHeight() < 140) then
				self:SetHeight(140);
			end
			self:Layout();
		end
		sender:SetPosition(self:GetWidth() - sender:GetWidth(),
			self:GetHeight() - sender:GetHeight());
	end

	self:Layout();
end

function MainWindow:Layout()
	self.text:SetSize(self:GetWidth() - (30 * 2) - 10, self:GetHeight() - 80 - 30);
	self.scrollbar:SetSize(10, self.text:GetHeight());
	self.scrollbar:SetPosition(self.text:GetLeft() + self.text:GetWidth() + 5, self.text:GetTop());
end

function MainWindow:ReloadHistory()
    local text = "";
    for _,msg in ipairs(history) do
        if (matchesFilter(msg)) then
            text = text .. format(msg);
        end
    end
    self.text:SetText(text);
end

